/*
 *----------------------------------------------------------------------
 *    micro T-Kernel 3.00.05
 *
 *    Copyright (C) 2006-2021 by Ken Sakamura.
 *    This software is distributed under the T-License 2.2.
 *----------------------------------------------------------------------
 *
 *    Released by TRON Forum(http://www.tron.org) at 2021/11.
 *
 *----------------------------------------------------------------------
 */

#include <sys/machine.h>
#ifdef IOTE_RZA2M

/*
 *      devinit.c (RZ/A2M IoT-Engine)
 *      Device-Dependent Initialization
 */

#include <sys/sysdef.h>
#include <tm/tmonitor.h>
#include <tk/device.h>

#include "kernel.h"
#include "sysdepend.h"

/* ------------------------------------------------------------------------ */

/*
 * Initialization before micro T-Kernel starts
 */

EXPORT ER knl_init_device( void )
{
        return E_OK;
}

/* ------------------------------------------------------------------------ */
/*
 * Start processing after T-Kernel starts
 *      Called from the initial task contexts.
 */
EXPORT ER knl_start_device( void )
{
        ER     err;
        
#if USE_SDEV_DRV

        /* Serial ch.4 "sere" */
        #if DEVCNF_USE_SER
                err = dev_init_ser(4);
                if(err < E_OK) return err;
        #endif

#endif
        return E_OK;
}

#if USE_SHUTDOWN
/* ------------------------------------------------------------------------ */
/*
 * System finalization
 *      Called just before system shutdown.
 *      Execute finalization that must be done before system shutdown.
 */
EXPORT ER knl_finish_device( void )
{
        return E_OK;
}

#endif /* USE_SHUTDOWN */

#endif /* IOTE_RZA2M */
